test-lib.sh 17.0 KB
Newer Older
1 2 3 4
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#
5 6 7 8 9 10 11 12 13 14 15 16
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/ .
17

18 19 20
# Keep the original TERM for say_color
ORIGINAL_TERM=$TERM

21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37
# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in 'trash directory' subdirectory.
if test -z "$TEST_DIRECTORY"
then
	# We allow tests to override this, in case they want to run tests
	# outside of t/, e.g. for running tests on the test library
	# itself.
	TEST_DIRECTORY=$(pwd)
fi
if test -z "$TEST_OUTPUT_DIRECTORY"
then
	# Similarly, override this to store the test-results subdir
	# elsewhere
	TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
fi
GIT_BUILD_DIR="$TEST_DIRECTORY"/..

38 39 40 41 42 43 44 45 46
################################################################
# It appears that people try to run tests without building...
"$GIT_BUILD_DIR/git" >/dev/null
if test $? != 1
then
	echo >&2 'error: you do not seem to have built git yet.'
	exit 1
fi

47 48 49
. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
export PERL_PATH SHELL_PATH

50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65
# if --tee was passed, write the output not only to the terminal, but
# additionally to the file test-results/$BASENAME.out, too.
case "$GIT_TEST_TEE_STARTED, $* " in
done,*)
	# do not redirect again
	;;
*' --tee '*|*' --va'*)
	mkdir -p test-results
	BASE=test-results/$(basename "$0" .sh)
	(GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
	 echo $? > $BASE.exit) | tee $BASE.out
	test "$(cat $BASE.exit)" = 0
	exit
	;;
esac

66 67
# For repeatability, reset the environment to known value.
LANG=C
68
LC_ALL=C
69
PAGER=cat
70
TZ=UTC
71 72
TERM=dumb
export LANG LC_ALL PAGER TERM TZ
73
EDITOR=:
74 75 76 77
# A call to "unset" with no arguments causes at least Solaris 10
# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
# deriving from the command substitution clustered with the other
# ones.
78
unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79
	my @env = keys %ENV;
80 81 82 83 84 85 86 87
	my $ok = join("|", qw(
		TRACE
		DEBUG
		USE_LOOKUP
		TEST
		.*_TEST
		PROVE
		VALGRIND
88
		UNZIP
89
		PERF_
90 91
	));
	my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 93
	print join("\n", @vars);
')
J
Jeff King 已提交
94
unset XDG_CONFIG_HOME
95 96 97 98
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
99
GIT_MERGE_VERBOSITY=5
100 101
GIT_MERGE_AUTOEDIT=no
export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 103
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
104
export EDITOR
105

106 107
# Add libc MALLOC and MALLOC_PERTURB test
# only if we are not executing the test with valgrind
J
Junio C Hamano 已提交
108
if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
109
   test -n "$TEST_NO_MALLOC_CHECK"
J
Junio C Hamano 已提交
110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125
then
	setup_malloc_check () {
		: nothing
	}
	teardown_malloc_check () {
		: nothing
	}
else
	setup_malloc_check () {
		MALLOC_CHECK_=3	MALLOC_PERTURB_=165
		export MALLOC_CHECK_ MALLOC_PERTURB_
	}
	teardown_malloc_check () {
		unset MALLOC_CHECK_ MALLOC_PERTURB_
	}
fi
126

127 128 129 130
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

B
Bert Wesarg 已提交
131
unset GREP_OPTIONS
132
unset UNZIP
B
Bert Wesarg 已提交
133

134
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
135 136 137 138 139 140
1|2|true)
	echo "* warning: Some tests will not work if GIT_TRACE" \
		"is set as to trace on STDERR ! *"
	echo "* warning: Please set GIT_TRACE to something" \
		"other than 1, 2 or true ! *"
	;;
141 142
esac

143 144 145 146 147 148
# Convenience
#
# A regexp to match 5 and 40 hexdigits
_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"

J
Junio C Hamano 已提交
149 150 151
# Zero SHA-1
_z40=0000000000000000000000000000000000000000

152 153 154 155
# Line feed
LF='
'

156 157
export _x05 _x40 _z40 LF

158 159 160 161 162 163
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh
164 165 166 167 168 169 170 171
[ "x$ORIGINAL_TERM" != "xdumb" ] && (
		TERM=$ORIGINAL_TERM &&
		export TERM &&
		[ -t 1 ] &&
		tput bold >/dev/null 2>&1 &&
		tput setaf 1 >/dev/null 2>&1 &&
		tput sgr0 >/dev/null 2>&1
	) &&
172
	color=t
173 174 175 176 177 178

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
179 180
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
181
	-l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
J
Junio C Hamano 已提交
182
		GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
183
	-h|--h|--he|--hel|--help)
184
		help=t; shift ;;
185 186
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
187
	-q|--q|--qu|--qui|--quie|--quiet)
188 189 190
		# Ignore --quiet under a TAP::Harness. Saying how many tests
		# passed without the ok/not ok details is always an error.
		test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
191 192
	--with-dashes)
		with_dashes=t; shift ;;
193
	--no-color)
194
		color=; shift ;;
195
	--va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
196
		valgrind=t; verbose=t; shift ;;
197 198
	--tee)
		shift ;; # was handled already
199 200 201
	--root=*)
		root=$(expr "z$1" : 'z[^=]*=\(.*\)')
		shift ;;
202
	*)
203
		echo "error: unknown test option '$1'" >&2; exit 1 ;;
204 205 206
	esac
done

207 208
if test -n "$color"
then
209
	say_color () {
210 211 212
		(
		TERM=$ORIGINAL_TERM
		export TERM
213
		case "$1" in
214 215 216
		error)
			tput bold; tput setaf 1;; # bold red
		skip)
A
Adam Spiers 已提交
217
			tput setaf 4;; # blue
218 219
		warn)
			tput setaf 3;; # brown/yellow
220
		pass)
221
			tput setaf 2;; # green
222
		info)
223
			tput setaf 6;; # cyan
224 225
		*)
			test -n "$quiet" && return;;
226 227
		esac
		shift
228
		printf "%s" "$*"
229
		tput sgr0
230
		echo
231
		)
232 233 234
	}
else
	say_color() {
235
		test -z "$1" && test -n "$quiet" && return
236
		shift
237
		printf "%s\n" "$*"
238 239 240 241 242
	}
fi

error () {
	say_color error "error: $*"
243
	GIT_EXIT_OK=t
244 245 246 247 248 249 250
	exit 1
}

say () {
	say_color info "$*"
}

251 252 253 254 255 256 257 258 259
test "${test_description}" != "" ||
error "Test script did not set test_description."

if test "$help" = "t"
then
	echo "$test_description"
	exit 0
fi

260
exec 5>&1
J
Jeff King 已提交
261
exec 6<&0
262 263 264 265 266 267 268 269 270
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0
J
Junio C Hamano 已提交
271 272
test_fixed=0
test_broken=0
273
test_success=0
274

275 276
test_external_has_tap=0

277
die () {
278 279 280 281 282 283 284 285
	code=$?
	if test -n "$GIT_EXIT_OK"
	then
		exit $code
	else
		echo >&5 "FATAL: Unexpected exit with code $code"
		exit 1
	fi
286 287
}

288
GIT_EXIT_OK=
289
trap 'die' EXIT
290

291 292
# The user-facing functions are loaded from a separate file so that
# test_perf subshells can have them too
293
. "$TEST_DIRECTORY/test-lib-functions.sh"
294

J
Junio C Hamano 已提交
295 296 297 298
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
299
	test_success=$(($test_success + 1))
300
	say_color "" "ok $test_count - $@"
301 302
}

J
Junio C Hamano 已提交
303
test_failure_ () {
304
	test_failure=$(($test_failure + 1))
305
	say_color error "not ok $test_count - $1"
306
	shift
307
	echo "$@" | sed -e 's/^/#	/'
308
	test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
J
Junio C Hamano 已提交
309 310
}

J
Junio C Hamano 已提交
311 312
test_known_broken_ok_ () {
	test_fixed=$(($test_fixed+1))
313
	say_color error "ok $test_count - $@ # TODO known breakage vanished"
J
Junio C Hamano 已提交
314 315 316 317
}

test_known_broken_failure_ () {
	test_broken=$(($test_broken+1))
318
	say_color warn "not ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
319
}
J
Junio C Hamano 已提交
320 321

test_debug () {
322
	test "$debug" = "" || eval "$1"
323 324
}

325 326 327
test_eval_ () {
	# This is a separate function because some tests use
	# "return" to end a test_expect_success block early.
J
Jeff King 已提交
328
	eval </dev/null >&3 2>&4 "$*"
329 330
}

331
test_run_ () {
332
	test_cleanup=:
333
	expecting_failure=$2
334
	test_eval_ "$1"
335
	eval_ret=$?
336 337 338

	if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
	then
J
Junio C Hamano 已提交
339
		setup_malloc_check
340
		test_eval_ "$test_cleanup"
J
Junio C Hamano 已提交
341
		teardown_malloc_check
342
	fi
343 344
	if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
	then
345 346
		echo ""
	fi
347
	return "$eval_ret"
348 349
}

350
test_skip () {
351
	test_count=$(($test_count+1))
352 353 354
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
355
		case $this_test.$test_count in
356 357
		$skp)
			to_skip=t
358
			break
359 360
		esac
	done
361 362
	if test -z "$to_skip" && test -n "$test_prereq" &&
	   ! test_have_prereq "$test_prereq"
363 364 365
	then
		to_skip=t
	fi
366 367
	case "$to_skip" in
	t)
368
		of_prereq=
369
		if test "$missing_prereq" != "$test_prereq"
370
		then
371
			of_prereq=" of $test_prereq"
372 373
		fi

374
		say_color skip >&3 "skipping test: $@"
375
		say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
376 377 378 379 380 381 382 383
		: true
		;;
	*)
		false
		;;
	esac
}

384 385 386 387 388
# stub; perf-lib overrides it
test_at_end_hook_ () {
	:
}

389
test_done () {
390
	GIT_EXIT_OK=t
391

392 393
	if test -z "$HARNESS_ACTIVE"
	then
394
		test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
395
		mkdir -p "$test_results_dir"
396 397
		base=${0##*/}
		test_results_path="$test_results_dir/${base%.sh}-$$.counts"
398

399 400 401 402 403 404 405 406
		cat >>"$test_results_path" <<-EOF
		total $test_count
		success $test_success
		fixed $test_fixed
		broken $test_broken
		failed $test_failure

		EOF
407
	fi
J
Junio C Hamano 已提交
408 409 410

	if test "$test_fixed" != 0
	then
411
		say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
J
Junio C Hamano 已提交
412 413 414
	fi
	if test "$test_broken" != 0
	then
415
		say_color warn "# still have $test_broken known breakage(s)"
416 417 418 419 420
	fi
	if test "$test_broken" != 0 || test "$test_fixed" != 0
	then
		test_remaining=$(( $test_count - $test_broken - $test_fixed ))
		msg="remaining $test_remaining test(s)"
421
	else
422
		test_remaining=$test_count
423
		msg="$test_count test(s)"
J
Junio C Hamano 已提交
424
	fi
425
	case "$test_failure" in
426
	0)
427
		# Maybe print SKIP message
428 429 430 431
		if test -n "$skip_all" && test $test_count -gt 0
		then
			error "Can't use skip_all after running some tests"
		fi
432 433
		[ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"

434 435
		if test $test_external_has_tap -eq 0
		then
436
			if test $test_remaining -gt 0
437 438 439
			then
				say_color pass "# passed all $msg"
			fi
440 441
			say "1..$test_count$skip_all"
		fi
J
Johannes Schindelin 已提交
442 443 444 445 446

		test -d "$remove_trash" &&
		cd "$(dirname "$remove_trash")" &&
		rm -rf "$(basename "$remove_trash")"

447 448
		test_at_end_hook_

449 450 451
		exit 0 ;;

	*)
452 453
		if test $test_external_has_tap -eq 0
		then
454 455 456
			say_color error "# failed $test_failure among $msg"
			say "1..$test_count"
		fi
457

458 459 460 461 462
		exit 1 ;;

	esac
}

463
if test -n "$valgrind"
464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484
then
	make_symlink () {
		test -h "$2" &&
		test "$1" = "$(readlink "$2")" || {
			# be super paranoid
			if mkdir "$2".lock
			then
				rm -f "$2" &&
				ln -s "$1" "$2" &&
				rm -r "$2".lock
			else
				while test -d "$2".lock
				do
					say "Waiting for lock on $2."
					sleep 1
				done
			fi
		}
	}

	make_valgrind_symlink () {
485 486 487 488 489 490 491
		# handle only executables, unless they are shell libraries that
		# need to be in the exec-path.  We will just use "#!" as a
		# guess for a shell-script, since we have no idea what the user
		# may have configured as the shell path.
		test -x "$1" ||
		test "#!" = "$(head -c 2 <"$1")" ||
		return;
492 493

		base=$(basename "$1")
494
		symlink_target=$GIT_BUILD_DIR/$base
495 496 497 498 499 500 501
		# do not override scripts
		if test -x "$symlink_target" &&
		    test ! -d "$symlink_target" &&
		    test "#!" != "$(head -c 2 < "$symlink_target")"
		then
			symlink_target=../valgrind.sh
		fi
502 503 504 505
		case "$base" in
		*.sh|*.perl)
			symlink_target=../unprocessed-script
		esac
506 507 508 509 510 511 512
		# create the link, or replace it if it is out of date
		make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
	}

	# override all git executables in TEST_DIRECTORY/..
	GIT_VALGRIND=$TEST_DIRECTORY/valgrind
	mkdir -p "$GIT_VALGRIND"/bin
513
	for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
514 515 516
	do
		make_valgrind_symlink $file
	done
517 518
	# special-case the mergetools loadables
	make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
519 520 521 522 523 524 525 526 527 528 529
	OLDIFS=$IFS
	IFS=:
	for path in $PATH
	do
		ls "$path"/git-* 2> /dev/null |
		while read file
		do
			make_valgrind_symlink "$file"
		done
	done
	IFS=$OLDIFS
530 531 532
	PATH=$GIT_VALGRIND/bin:$PATH
	GIT_EXEC_PATH=$GIT_VALGRIND/bin
	export GIT_VALGRIND
533 534
elif test -n "$GIT_TEST_INSTALLED"
then
535 536
	GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
	error "Cannot run git from $GIT_TEST_INSTALLED."
537
	PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
538 539
	GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
else # normal case, use ../bin-wrappers only unless $with_dashes:
540
	git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
541 542 543 544
	if ! test -x "$git_bin_dir/git"
	then
		if test -z "$with_dashes"
		then
545 546 547 548 549
			say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
		fi
		with_dashes=t
	fi
	PATH="$git_bin_dir:$PATH"
550
	GIT_EXEC_PATH=$GIT_BUILD_DIR
551 552
	if test -n "$with_dashes"
	then
553
		PATH="$GIT_BUILD_DIR:$PATH"
554
	fi
555
fi
556
GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
J
Jeff King 已提交
557 558
unset GIT_CONFIG
GIT_CONFIG_NOSYSTEM=1
559
GIT_ATTR_NOSYSTEM=1
560
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
561

562 563 564 565 566 567 568 569 570 571
if test -z "$GIT_TEST_CMP"
then
	if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
	then
		GIT_TEST_CMP="$DIFF -c"
	else
		GIT_TEST_CMP="$DIFF -u"
	fi
fi

572
GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
573
export GITPERLLIB
574
test -d "$GIT_BUILD_DIR"/templates/blt || {
575 576
	error "You haven't built things yet, have you?"
}
577

J
Jeff King 已提交
578
if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
579
then
580
	GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
581
	export GITPYTHONLIB
582
	test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
583 584 585 586
		error "You haven't built git_remote_helpers yet, have you?"
	}
fi

587 588
if ! test -x "$GIT_BUILD_DIR"/test-chmtime
then
E
Eric Wong 已提交
589 590 591 592 593
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

594
# Test repository
J
Johannes Schindelin 已提交
595
test="trash directory.$(basename "$0" .sh)"
596 597 598
test -n "$root" && test="$root/$test"
case "$test" in
/*) TRASH_DIRECTORY="$test" ;;
599
 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
600
esac
601
test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
602
rm -fr "$TRASH_DIRECTORY" || {
603
	GIT_EXIT_OK=t
604 605 606 607
	echo >&5 "FATAL: Cannot prepare test area"
	exit 1
}

608 609 610
HOME="$TRASH_DIRECTORY"
export HOME

611 612
if test -z "$TEST_NO_CREATE_REPO"
then
613
	test_create_repo "$TRASH_DIRECTORY"
614
else
615
	mkdir -p "$TRASH_DIRECTORY"
616
fi
617 618
# Use -P to resolve symlinks in our working directory so that the cwd
# in subprocesses like git equals our $PWD (for pathname comparisons).
619
cd -P "$TRASH_DIRECTORY" || exit 1
620

621 622
this_test=${0##*/}
this_test=${this_test%%-*}
623 624
for skp in $GIT_SKIP_TESTS
do
625 626
	case "$this_test" in
	$skp)
627
		say_color info >&3 "skipping test $this_test altogether"
628
		skip_all="skip all tests in $this_test"
629 630 631
		test_done
	esac
done
632

633 634 635 636 637 638 639 640 641 642 643 644 645 646 647
# Provide an implementation of the 'yes' utility
yes () {
	if test $# = 0
	then
		y=y
	else
		y="$*"
	fi

	while echo "$y"
	do
		:
	done
}

648 649 650 651 652 653 654 655 656 657
# Fix some commands on Windows
case $(uname -s) in
*MINGW*)
	# Windows has its own (incompatible) sort and find
	sort () {
		/usr/bin/sort "$@"
	}
	find () {
		/usr/bin/find "$@"
	}
658 659 660
	sum () {
		md5sum "$@"
	}
661 662 663 664
	# git sees Windows-style pwd
	pwd () {
		builtin pwd -W
	}
665
	# no POSIX permissions
666
	# backslashes in pathspec are converted to '/'
667
	# exec does not inherit the PID
668
	test_set_prereq MINGW
669
	test_set_prereq NOT_CYGWIN
670 671 672 673 674 675
	test_set_prereq SED_STRIPS_CR
	;;
*CYGWIN*)
	test_set_prereq POSIXPERM
	test_set_prereq EXECKEEPSPID
	test_set_prereq NOT_MINGW
676
	test_set_prereq CYGWIN
677
	test_set_prereq SED_STRIPS_CR
678 679 680
	;;
*)
	test_set_prereq POSIXPERM
681
	test_set_prereq BSLASHPSPEC
682
	test_set_prereq EXECKEEPSPID
P
Pat Thoyts 已提交
683
	test_set_prereq NOT_MINGW
684
	test_set_prereq NOT_CYGWIN
685 686
	;;
esac
687

688
( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
689
test -z "$NO_PERL" && test_set_prereq PERL
690
test -z "$NO_PYTHON" && test_set_prereq PYTHON
M
Michał Kiedrowicz 已提交
691
test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
692
test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
693

694
# Can we rely on git's output in the C locale?
695 696 697 698
if test -n "$GETTEXT_POISON"
then
	GIT_GETTEXT_POISON=YesPlease
	export GIT_GETTEXT_POISON
699
	test_set_prereq GETTEXT_POISON
700 701 702
else
	test_set_prereq C_LOCALE_OUTPUT
fi
703

704 705 706 707 708 709 710 711
# Use this instead of test_cmp to compare files that contain expected and
# actual output from git commands that can be translated.  When running
# under GETTEXT_POISON this pretends that the command produced expected
# results.
test_i18ncmp () {
	test -n "$GETTEXT_POISON" || test_cmp "$@"
}

712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729
# Use this instead of "grep expected-string actual" to see if the
# output from a git command that can be translated either contains an
# expected string, or does not contain an unwanted one.  When running
# under GETTEXT_POISON this pretends that the command produced expected
# results.
test_i18ngrep () {
	if test -n "$GETTEXT_POISON"
	then
	    : # pretend success
	elif test "x!" = "x$1"
	then
		shift
		! grep "$@"
	else
		grep "$@"
	fi
}

730 731 732 733 734
test_lazy_prereq PIPE '
	# test whether the filesystem supports FIFOs
	rm -f testfifo && mkfifo testfifo
'

735 736 737 738
test_lazy_prereq SYMLINKS '
	# test whether the filesystem supports symbolic links
	ln -s x y && test -h y
'
739

740 741 742 743 744 745
test_lazy_prereq CASE_INSENSITIVE_FS '
	echo good >CamelCase &&
	echo bad >camelcase &&
	test "$(cat CamelCase)" != good
'

746 747 748 749 750 751 752 753 754 755 756 757 758
test_lazy_prereq UTF8_NFD_TO_NFC '
	# check whether FS converts nfd unicode to nfc
	auml=$(printf "\303\244")
	aumlcdiar=$(printf "\141\314\210")
	>"$auml" &&
	case "$(echo *)" in
	"$aumlcdiar")
		true ;;
	*)
		false ;;
	esac
'

759 760 761 762 763 764
test_lazy_prereq AUTOIDENT '
	sane_unset GIT_AUTHOR_NAME &&
	sane_unset GIT_AUTHOR_EMAIL &&
	git var GIT_AUTHOR_IDENT
'

765 766 767
# When the tests are run as root, permission tests will report that
# things are writable when they shouldn't be.
test -w / || test_set_prereq SANITY
768 769 770 771 772 773

GIT_UNZIP=${GIT_UNZIP:-unzip}
test_lazy_prereq UNZIP '
	"$GIT_UNZIP" -v
	test $? -ne 127
'